#include <stdio.h>          
/* shift, last check_line diff TBT, count in slip modify  */
#define n48    41           /* omr data number of a line */
#define half   24           /* 64: 30-12,27-11,26-7,25-6;24-7,23-6,22-9 */
#define p3     3            /* ignor  value */
#define sigma  3            /* bias,  edge, m20 */
#define sig20  3            /* bias,  edge, m20 */
#define m5     3            /* 0-m5 no 3bit out */
#define p6     8            /* mark minum width 8 poshort  ~15,16 */
#define hwmax 30
#define hw     6
#define m60   55
#define m40   40
int  fch;                   /* interput counter, line number */
int  p40,p60;               /* little adjusted in processing routine */
int  jp,x_c,x_w,c,cc,n41,bias3;  
int  error,nx,ns,ipeak,xpeak,xpeak0,ipp,dp,dx,shift;
int  slip[41],bias[41],c_xpeak[41], a[41];

/* -- bar par -- */
int b[500], bz, bip, bs;

unsigned char aa[64*n48];

FILE *fp0;
unsigned short uni[1728];
unsigned char a1728[1728];
unsigned char usb[960];           // 8+(864-8)+42+2+40+12(fill)
char f0[30];
short p41[41],barT,barX,barY,barL, topM,endM,m255;

main(int ac,char **av)
{ FILE *fp; int i;
  if(ac<2){ printf("\n\t*** Simulating omr3000 scanning a sheet ****\n");
            printf("\n\tUsage: cut37 01.prt [!]\n");
            printf("\n\tneed c5502.par support");
            printf("\n\tinclude:");
            printf("\n\tn41 p1 p2 ....");
            printf("\n\tbarT barX barY barL\n"); 
            printf("\n\t! make marker at outfile j*.prt\n"); 
            printf("\n\tafter run ja\n\n");
            exit(0); }
  readpar();
  readtbl();
  fp=fopen(av[1],"rb"); if(!fp){ printf("%s not found!\n",av[1]); exit(0); }
  strcpy(f0,av[1]); f0[0]='j'; fp0=fopen(f0,"wb");

  m255=0; if(ac>2)m255=1;                  // put marker to bmp;
  fch=topM=endM=0;
  p60=m60; p40=m40;
  for(i=0;i<n41;i++){ bias[i]=p60; slip[i]=0; }
  error=ipp=jp=nx=ipeak=0;   shift=64;
  bz=bip=bs=0;
  a[0]=0;
l10:
  fread(a1728,1,1728,fp); if(feof(fp))goto l20;
  work(); fch++; 
  if(error==0)cut(fch);
  if(barT && error==99)do_bar();
  goto l10;
l20:
  fclose(fp); fclose(fp0);
  printf("%s produced!\n",f0);
}

readtbl()
{ FILE *fp;
  fp=fopen("red.tbl","rb");if(!fp){printf("red.tbl not found!\n");exit(0);}
  fseek(fp,32,0);  fread(uni,2,1728,fp); fclose(fp);
}

readpar()
{ FILE *fp; int i; char a80[80];
  fp=fopen("c5502.par","r"); if(!fp){ printf("\n\tc5502.par not found!\n");
                                      exit(0); }
  fgets(a80,80,fp); sscanf(a80,"%d",&n41);
  for(i=0;i<n41;i++){ fgets(a80,80,fp); sscanf(a80,"%d",&p41[i]); }
  fgets(a80,80,fp); sscanf(a80,"%d %d %d %d",&barT,&barX,&barY,&barL);
  fclose(fp);
  printf("c5502.par\n%d ",n41); for(i=0;i<n41;i++)printf("%d ",p41[i]);
  printf("\n%d %d %d %d\n",barT,barX,barY,barL);
}

work()
{ short i,j,k,m,p;                         // [0-8]data resvered !!!
  for(i=16;i<1728;i++){                    // union
    m=(uni[i]>>8)*4; j=a1728[i]*4+2;
    k=(j>m)?j-m:0; k*=uni[i]&0xff; k>>=6; if(k>254)k=254;
    a1728[i]=k;
  } 
  if(fch>9 && topM==0){                    // get topM
    k=0; for(i=864-100;i<864+100;i++)if(a1728[i]<200)k++;
    if(k<9)topM=fch;
  }
  if(fch>999 && endM<9){                   // get endM
    k=0; for(i=864-100;i<864+100;i++)if(a1728[i]>20)k++;
    if(k<9)endM++; else endM=0;
//    if(endM>=9){ aa[((fch-1)&0x3f)*n48]=64; m255=0; }
    if(endM>=9){ aa[((nx+1)&0x3f)*n48]=64; m255=0; }
  }
  k=864; usb[k++]=n41;                     // extract for cut (omr2000)
  p=(fch&0x3f)*n48;
  for(i=0;i<n41;i++){
    j=p41[i]; m=a1728[j-1]+a1728[j]+a1728[j+1]; m*=10; m>>=7;
    aa[p++]=usb[k++]=63-m;                 // send cut_data
  }  
  k=864+42;
  if(a[0]){                                // send result
    if(a[0]!=255){
      usb[k++]=n41; for(i=0;i<n41;i++)usb[k++]=a[i]; usb[k++]=255; 
    } else {
      usb[k++]=bip+5; usb[k++]=255; 
      usb[k++]=error;                      // system error number
      usb[k++]=shift;                      
      usb[k++]=bs;                         // bar error_number
      usb[k++]=bip;
      for(i=1;i<=bip;i++)usb[k++]=a[i];    // bar 
      usb[k++]=255;                        // end_mark;
    }
    a[0]=0;                                // clear marker
  } else { usb[k++]=0; usb[k++]=0; }       // no result
  if(topM && barT && bz<barL){             // extract bar data
    if(barT==1 && fch==topM+barY){
      for(i=barX;i<barX+barL;i++){ b[bz++]=63-(a1728[i]>>2);
                                   if(m255)a1728[i]=255; }
    }
    if(barT==2 && fch>=topM+barY){
      b[bz++]=63-(a1728[barX]>>2); if(m255)a1728[barX]=255;
    }
  }
  if(m255 && topM)for(i=0;i<n41;i++)a1728[p41[i]]=255;  // mark extract position
  k=0;                                       
  for(i=0;i<8;i++)usb[k++]=a1728[i];         // put line head & shrink data
  for(i=16+(fch%2);i<1728;i+=2)usb[k++]=a1728[i];
  fwrite(usb,1,960,fp0);
}

cut(int fch)
{
  int i,j,k,l, k20,k33, sx,sz, points,sort[9];
L3:
  if(error)goto L10;                         /* error is "handware_error" */
  if(fch-half<nx) return;                    /* data not buffered yet */
L10:
  nx++;  cc=aa[(nx&0x3f)*n48];
  if(cc>63 || error ){
    printf("* err: %d shift: %d fch: %d\n",error,shift,fch);
    if(error==0)error=99;                    /* finish */
    return;
  }
  if(cc+2>=p40 && ipp==0)goto L3;            /* for 1ST black */
  ipp=255;
  if(jp==0){                                 /* find 1st mark */
    for(i=0;i<n41;i++){ sz=aa[(nx&0x3f)*n48+i]; if(bias[i]>sz)bias[i]=sz; }
 k=0; for(i=0;i<n41;i++)if(bias[i]>k)k=bias[i];
 if(k>m40/2){ ipp=0; goto L3; }             // bias not standable
    if(cc>p40 && ipeak==0){  ipeak=1;  ns=nx-1; }     /* find left_edge */
    if(ipeak==1 && cc<p40) {                          /* find right_edge */
      x_c=xpeak=(ns+nx)>>1;  x_w=6;
      if(nx-ns <p6 )goto L99;
      for(i=1;i<n41;i++){                             /* cal slip */
        k=sx=cc=0;
        for(j=xpeak-x_w;j<=xpeak+x_w;j++){
          sz=aa[(j&0x3f)*n48+i];  if(sz>cc)cc=sz;
          k+=(sz*(j-xpeak));                       
          sx+=sz;
        }
        if(sx<1)sx=1;   xpeak+=(k*2/sx+1)>>1;
        slip[i]=xpeak-x_c;                            /* if end */
        l=aa[(xpeak&0x3f)*n48+i]-cc;
        if(l<0)l=-l; if(l>sigma)slip[i]=slip[i-1];
        cc=cc*3/4; k=xpeak-30; if(k<10)k=10;
        l=1; for(j=xpeak;j>k;j--)if(cc>aa[(j&0x3f)*n48+i]){ l=0; break; }
        if(l){ slip[i]=slip[i-1]; if(i==15)break; }   /* no black line */
      }
      jp=1;
      return;
    }
  }
  if(jp){
    if(cc>p40 && ipeak==0){  ipeak=1;  ns=nx-1;    }  /* find left */
    if(ipeak==1 && cc<p40) {                          /* find right */
      xpeak0=xpeak;    xpeak=(ns+nx)>>1;
      if(nx-ns <p6 )goto L99;
      x_w=(nx-ns)>>1;  if(x_w>hwmax)x_w=hwmax;
      if(nx-ns-3 > dp && jp>3){
        xpeak=xpeak0; nx=xpeak+(dp*5)/4;  xpeak0=nx+dp/2;
        for(i=nx;i<xpeak0;i++)aa[(i&0x3f)*n48]=bias[0];
        goto L3;
      }
      l=xpeak-xpeak0;
      if(jp==2 || (jp==3 && l<dp)) { dp=l; dx=nx-ns+3; }
      if(jp>3 && nx-ns>dx) xpeak=xpeak0+dp;
      if(jp==1){
        p40=(aa[(xpeak&0x3f)*n48]-bias[0])/2+bias[0];
        if(p40>45)p40=45; if(p40<36)p40=36;
      }
      for(i=1;i<n41;i++){
        k=xpeak+slip[i];
        c= points=0; bias3=3*(p60-bias[i])/15+bias[i];  /* find peak */
        for(j=k-x_w;j<=k+x_w;j++){
          sz=aa[(j&0x3f)*n48+i];
          if(sz>c){ c=sz; x_c=j; }                      /* find posi */
          if(sz>bias3)points++;
        }
        calcck20(i);
        if(cc<=1){
          l=0; for(j=k-4;j<=k+4;j++)sort[l++]=aa[(j&0x3f)*n48+i];
          for(j=0;j<8;j++)for(l=j+1;l<9;l++)if(sort[j]>sort[l]){
            k20=sort[l]; sort[l]=sort[j]; sort[j]=k20;
          }
          j=bias[i]-sort[4]; if(j<0)j=-j;
          bias[i]=(j<=sigma)?sort[4]:(bias[i]+sort[4])/2;
        }
        if(cc<p3)cc=0; else if( points*3 < x_w*2 )jduge(i,k);
        if(cc>m5){
          k20=findk(i,20);   k33=findk(i,33); if(k20==0)k20=1;
          k=40-(k33*24/k20); k=findk(i,k);
          l=k/6; if(l>7)l=7; l<<=4;   cc|=l;
        }
        a[i]=cc; c_xpeak[i]=x_c-xpeak;
      }
printf("%02d: ",jp);
for(i=1;i<n41;i++)if(a[i]==0)printf("   ");else printf("%02x ",a[i]);
printf("\n");
      a[0]=jp;                              // for usb transfer data
      for(i=1;i<n41;i++)if(a[i]==0)goto l50;
      shift=c_xpeak[n41-1]-slip[n41-1]; if(shift<0)shift+=128;
// for(i=1;i<n41;i++)printf("%d ",slip[i]); printf("\n");
      
l50:
      jp++;  ipeak=0;
    }
  } goto L3;
L99: ipeak=0; goto L3;
}

jduge(int i,int k)
{
  int j,sz;
  if(aa[((k-x_w)&0x3f)*n48+i]>=bias3){
    for(j=k-x_w;j>=k-2*x_w;j--){ sz=aa[(j&0x3f)*n48+i];
      if(sz>c)c=sz; if(sz<bias3){ calcck20(i); return; }
    } cc=0;
  }
  if(aa[((k+x_w)&0x3f)*n48+i]>=bias3){
    for(j=k+x_w;j<=k+2*x_w;j++){ sz=aa[(j&0x3f)*n48+i];
      if(sz>c)c=sz; if(sz<bias3){ calcck20(i); return; }
    } cc=0;
  }
}

calcck20(int i)
{ cc=(c-bias[i])*15/(p60-bias[i]);  if(cc>15)cc=15; if(cc<0)cc=0; }

int findk(int i, int kk)
{
  int j,k,m20,m80,sz;
l20:
  m80=(c-bias[i])*9/10+bias[i]; k=0;
  m20=(c-bias[i])*kk/100; if(m20<sig20)m20=sig20; m20+=bias[i];
  for(j=x_c;j>x_c-p60;j--){ sz=aa[(j&0x3f)*n48+i];
    if(sz<m80)k++; if(c<sz){ c=sz; goto l20; }
    if(sz<m20)break;
  }
  for(j=x_c;j<x_c+p60;j++){ sz=aa[(j&0x3f)*n48+i];
    if(sz<m80)k++; if(c<sz){ c=sz; goto l20; }
    if(sz<m20)break;
  } return(k);
}

/* ------bar--------*/
#define    p10 15               // old is 9, too small
#define white8 8

int  mta[108]={
0x455,0x545,0x554,0x116,0x125,0x215,0x152,0x161,0x251,0x512,0x521,0x611,
0x059,0x149,0x158,0x095,0x185,0x194,0x590,0x509,0x518,0x491,0x581,0x848,
0x815,0x905,0x914,0x851,0x941,0x950,0x446,0x464,0x644,0x026,0x206,0x224,
0x062,0x242,0x260,0x422,0x602,0x620,0x04a,0x068,0x248,0x086,0x0a4,0x284,
0x884,0x428,0x608,0x482,0x4a0,0x488,0x806,0x824,0xa04,0x842,0x860,0xa40,
0x8c0,0x530,0xe00,0x017,0x035,0x107,0x134,0x305,0x314,0x053,0x071,0x143,
0x170,0x341,0x350,0x710,0x503,0xc80,0x701,0x2c0,0x01d,0x10d,0x11c,0x0d1,
0x1c1,0x1d0,0xc11,0xd01,0xd10,0x44c,0x4c4,0xc44,0x00e,0x02c,0x20c,0x0c2,
0x0e0,0xc02,0xc20,0x08c,0x0c8,0x80c,0xc08,0x431,0x413,0x419,0x680,0x40a};

do_bar()
{
  int i;
//for(i=0;i<bz;i++)printf("%d ",b[i]); printf("\n"); 
  bs=mark(); /* bs=0~ok, 1~nocode,2~nohead,3~noend,4~crc,5~nodata  */
  printf("& %d %d_%d: ",bs,barX,barY);
  for(i=1;i<=bip;i++)printf("%c",a[i]); printf("\n");
  a[0]=255;                         // for usb transfer data of last_line
  barT=0;                           // done
}

mark()
{
  int i,j,k,l,bs, zm,mz,zp, checkcode, codesort, rsh[100],slp[100];
  mz=m60;
  for(i=0;i<barL;i++){
    if(b[i]<m40 || b[i]<b[i-1] || b[i]<b[i+1])continue; if(b[i]<mz)mz=b[i];
  }
  bs=0;
  for(i=60;i<barL-60;i++){
    if(b[i]>=mz || b[i]>b[i-1] || b[i]>b[i+1])continue; if(b[i]>bs)bs=b[i];
  }
  bs=(mz-bs+1)/2;
  if(bs>p10)bs=p10;
  zm=mz-bs;
  zp= j= slp[0]=0;
  for(i=0;i<barL;i++){
    if(zp==0 && b[i]<zm)continue;                 
    if(zp==0){ zp=1;  slp[j++]=calm(i,zm); }
    if(zp==1){ if(b[i]<zm){ slp[j++]=calm(i,zm); zp=2; } continue; }
    if(zp==2)  if(b[i]>zm){ slp[j++]=calm(i,zm); zp=1; }
  }
  j--; for(i=1;i<j;i++)rsh[i-1]=(slp[i]-slp[i-1]+17)/33;
  l=0; k=j; if(rsh[1]>white8)l=2; if(rsh[k-2]>white8)k=k-2;
  mz=(k-l)/6;
  if(mz==0)return(5);                              /* no data */
  zm=(slp[mz*6+l]-slp[l])/(11*mz);
  for(i=l+1;i<=k;i++){
    bs=slp[i]-slp[i-1];
    if(bs<(zm*3/4)){ bs=(zm-bs)/2; slp[i]+=bs; slp[i-1]-=bs; }
  }
  j=0; for(i=l+1;i<=k;i++)slp[j++]=slp[i]-slp[i-1];
  if(slp[3]<slp[j-4])                              /* reversed */
    for(i=0;i<j/2;i++) { bs=slp[i]; slp[i]=slp[j-i-1]; slp[j-i-1]=bs;}
  for(i=0;i<j-1;i+=6){
    zp=(slp[i]+slp[i+1]+slp[i+2]+slp[i+3]+slp[i+4]+slp[i+5]+zm/2)/11;
    for(l=i;l<i+6;l++){
      slp[l]=(slp[l]+zp/2)/zp; if(slp[l]==0)slp[l]=1; if(slp[l]>=5)slp[l]=4;
    }
  }
  for(i=zp=l=0;i<j;i+=6){
    bs=0; for(k=0;k<6;k++){bs<<=2; bs|=slp[l++]-1;}  slp[zp++]=bs;
  } zp--;
  checkcode= l= bs=0;
  for(i=0;i<zp;i++){
    for(j=0;j<107;j++)if(slp[i]==mta[j])goto l10;
    return(1);
l10:
    slp[l++]=j;
  } l--;
  codesort=slp[0]-102;
  if(codesort<1 || codesort >3)return(2);        /* no head */
  if(slp[l]!=106)return(3);                      /* no end */
  for(i=1;i<l;i++)checkcode+=slp[i-1]*(i-1);  checkcode+=slp[0];
  checkcode%=103;
  l--;  if(checkcode!=slp[l])bs=4;               /* err of check code */
  for(i=1;i<l;i++)
  if(codesort==3){
    if(slp[i]==102)continue;                     /* 40923 for UCC/EAN */
    if(slp[i]>=100)codesort=2;
    else { a[++bip]=slp[i]/10+48; a[++bip]=slp[i]%10+48; }
  } else { if(slp[i]==99)codesort=3; else a[++bip]=slp[i]+32; }
  return(bs);
}

int calm(int i,int zm)
{
  if(b[i]==b[i-1])return i*10;
  return  i*10-(b[i]-zm)*10/(b[i]-b[i-1]);
}
